unit CreateWaterMarkDialog;

interface

uses
  Windows,   Messages,  SysUtils,    Variants,
  Classes,   Graphics,  Controls,    Forms,
  Dialogs,   StdCtrls,  ExtCtrls,   WMImageUnit,
  DateUtils, MD5,       NGImages;

type
  TCreateWatermarkForm = class(TForm)
    NameEdit            : TEdit;
    CompanyNameEdit     : TEdit;
    CopyrightCommentEdit: TEdit;
    TimeStampEdit       : TEdit;
    Label1: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    CreateWaterMarkButton: TButton;
    CancelButton: TButton;
    Label5: TLabel;
    FileNameEdit: TEdit;
    InvBkGroundCheckBox: TCheckBox;
    RandBkGroundCheckBox: TCheckBox;
    Bevel1: TBevel;
    procedure CancelButtonClick(Sender: TObject);
    procedure CreateWaterMarkButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  End;

var
 CreateWatermarkForm: TCreateWatermarkForm;

implementation

{$R *.dfm}

Procedure CreateWaterMark(WMI:WMInfo);
 Const MaxX = 300;
       MaxY = 85;
 var BitMap : TBitMap;
     NG     : TNGImage;
     I      : Integer;
     Col    : TColor;
Begin

 BitMap := TBitMap.Create;
 Bitmap.PixelFormat := pf24Bit;
 Bitmap.Width  := MaxX;
 Bitmap.Height := MaxY;

 If WMI.InvBkGround Then Bitmap.Canvas.Brush.Color:=clWhite
  Else  Bitmap.Canvas.Brush.Color:=clBlack;

 Bitmap.Canvas.FillRect(Rect(0,0,MaxX,MaxY));

 If WMI.RandBkGround Then
  Begin
   Randomize;
   If WMI.InvBkGround Then Col := clBlack
    Else Col:=clWhite;
   For I:= 1 to 500 Do
   Begin
    Bitmap.Canvas.Pixels[Random(MaxX),Random(MaxY)]:= Col;
   End;
  End;

 If WMI.InvBkGround Then
  Begin
   Bitmap.Canvas.Brush.Color:=clWhite;
   BitMap.Canvas.Font.Color :=clBlack;
  End
  Else
  Begin
   Bitmap.Canvas.Brush.Color:=clBlack;
   BitMap.Canvas.Font.Color :=clWhite;
  End;

 Bitmap.Canvas.Brush.style := bsClear;
 Bitmap.Canvas.TextOut(5,5,'Name: '+WMI.Name);
 Bitmap.Canvas.TextOut(5,20,'Company Name:'+WMI.CompanyName);
 Bitmap.Canvas.TextOut(5,35,'Copyright: ' +WMI.Copyright);
 Bitmap.Canvas.TextOut(5,50,'Time Stamp: ' +WMI.TimeStamp);
 Bitmap.Canvas.TextOut(5,65,'Secure Key: ' +WMI.SecureKey);

 NG := TNGImage.Create;
 Try
  NG.Assign (Bitmap);
  NG.SaveToPNGfile (WMI.FileName+'.png');
 Finally
  NG.Free;
 End;
 Bitmap.Free;

End;

Function GetSecureKey(WMI:WMInfo):String;
Var MD5Str:String;
Begin

 MD5Str:= WMI.Name+
          WMI.CompanyName+
          WMI.Copyright+
          WMI.TimeStamp+
          WMI.FileName;

 Result:= UpperCase(MD5PrintFull(MD5String(MD5Str)));

End;

procedure TCreateWatermarkForm.CancelButtonClick(Sender: TObject);
Begin
 Close();
End;

Procedure TCreateWatermarkForm.CreateWaterMarkButtonClick(Sender: TObject);
Var WMI:WMInfo;
    WM :WaterMarkImage;
Begin
 WMI.Name       := NameEdit.Text;
 WMI.CompanyName:= CompanyNameEdit.Text;
 WMI.Copyright  := CopyrightCommentEdit.Text;
 WMI.TimeStamp  := TimeStampEdit.Text;
 WMI.FileName   := FileNameEdit.Text;
 WMI.SecureKey  := GetSecureKey(WMI);

 If RandBkGroundCheckBox.Checked Then WMI.RandBkGround:=True
  Else WMI.RandBkGround:= False;

 If InvBkGroundCheckBox.Checked Then WMI.InvBkGround:=True
  Else WMI.InvBkGround:=False;

 CreateWaterMark(WMI);
 Close();

End;



Procedure TCreateWatermarkForm.FormShow(Sender: TObject);
 Const DaysOfWeek  : Array[1..7] Of string  = ('Monday','Tuesday','Wednesday','Thrusday','Friday','Saturday','Sunday');
 Const MonthsOfYear: Array[1..12] Of string = ('January','Feburary','March','April','May','June','July','August','September','October','November','December');
Begin
 NameEdit.Text            := '';
 CompanyNameEdit.Text     := '';
 CopyrightCommentEdit.Text:= '';
 TimeStampEdit.Text       := DaysOfWeek[DayOfTheWeek(Date)]+' '+IntToStr(DayOfTheMonth(Date))+' '+MonthsOfYear[MonthOf(Date)]+' '+IntToStr(YearOf(Date))+' '+TimeToStr(Time);
 FileNameEdit.Text        := '';
End;


end.
